package fr.ullrimax.rtp;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.WorldBorder;
import org.bukkit.block.Sign;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.plugin.java.JavaPlugin;


public class RTP extends JavaPlugin implements Listener{

	public void onEnable(){
		saveDefaultConfig();
		reloadConfig();
		Bukkit.getServer().getPluginManager().registerEvents(this, this);
		System.out.println("[RandomTeleport] Plugin Enabled !");
	}

	public void onDisable(){
	}

	public HashMap<String, Long> cooldowns = new HashMap<String, Long>();
	public HashMap<String, Long> delays = new HashMap<String, Long>();
	List<String> player = new ArrayList<String>();
	Random r = new Random();
	Location TP;
	int delay = this.getConfig().getInt("delay");
	int x;
	int z;
	int y;
	int zMax;
	int zMin;
	int xMax;
	int xMin;
	int i = 0;
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (label.equalsIgnoreCase("rtp") || label.equalsIgnoreCase("wild") || label.equalsIgnoreCase("wilderness")){


			if(args.length >= 2 && !(sender instanceof Player)){   // rtp tp player

				Player tped = Bukkit.getPlayer(args[0]); 


				if (tped == null){
					return false;
				}
				if (!tped.isOnline()){
					return false;
				}


				World world =  getServer().getWorld(args[1]);
				if (world == null){
					return false;
				}
				genCoord(world, tped);

				if (args.length == 3){ // SI SELECTION DE BIOME
					int ii = 0;
					while (!TP.getBlock().getBiome().toString().equalsIgnoreCase(args[2])){
						ii = ii+1;
						genCoord(world, tped);
						if (ii>100){
							break;
						}
					}
				}
				if (i>300){i=0;return false;};
				tpPlayer(tped, TP);
				return true;

			}
			if (sender instanceof Player){
				Player p = (Player) sender;
				if (args.length == 0){ // If the player uses /RTP
					if (!p.hasPermission("rtp.tp")){
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage")));
						return false;
					}
					if (!p.hasPermission("rtp.bypass") && checkCD(p) == true){
						return false;
					}
					if(p.hasPermission("rtp.bypass") || checkCD(p) == false ){
						genCoord(p.getWorld(), p);
						if (i>300){i=0;return false;};
						tpPlayer(p, TP);
					}
				}


				if (args.length > 0){

					if (args[0].equalsIgnoreCase("set")){ // Set the center of the square
						if (!p.hasPermission("rtp.set")){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage")));
							return false;
						}
						if (args.length == 2){
							if (!isInteger(args[1])){
								p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("mustintegermessage")));
								return false;
							}
							World world = p.getWorld();
							Location loc = p.getLocation();
							int value = Integer.parseInt(args[1]);
							x = (int) loc.getX();
							z = (int) loc.getZ();
							zMax = z+value;
							zMin = z-value;
							xMax = x+value;
							xMin = x-value;

							this.getConfig().set("Worlds." + world.getName() + ".zMax", zMax);
							this.getConfig().set("Worlds." + world.getName() + ".zMin", zMin);
							this.getConfig().set("Worlds." + world.getName() + ".xMax", xMax);
							this.getConfig().set("Worlds." + world.getName() + ".xMin", xMin);
							saveConfig();
							String setmessage = this.getConfig().getString("setmessage");
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',setmessage.replace("$value$", Integer.toString(value))));
						}  else {
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("usagesetmessage")));
						}
						return true;
					}

					if(args[0].equals("help")){
						help(p);
						return true;
					}

					if(args[0].equals("reload") && p.hasPermission("rtp.reload")){
						reloadConfig();
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("reloadmessage")));
						return true;
					}

					if(args[0].equals("tpprotection") && p.hasPermission("rtp.tpprotection")){
						if (args.length > 1){
							if (args[1].equalsIgnoreCase("True") || args[1].equalsIgnoreCase("False")){
								this.getConfig().set("tpprotection", Boolean.parseBoolean(args[1]));
								saveConfig();
								p.sendMessage(ChatColor.GREEN + "Settings changed !");
								return true;
							}else { p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("usagetpprotectionmessage"))); return false; }
						} else { p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("usagetpprotectionmessage"))); return false; }
					}

					if(args[0].equalsIgnoreCase("cooldown")){ 
						if(args.length<2){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("usagecooldownmessage")));
							return false;
						}
						if (!p.hasPermission("rtp.cooldown")){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage")));
							return false;
						}

						if (isInteger(args[1]) == false){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("usagecooldownmessage")));
							return false;
						}
						int cd = Integer.parseInt(args[1]);

						this.getConfig().set("cooldown", cd);
						saveConfig();
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("cooldownsetmessage")));
						return true; 
					}

					if(args[0].equalsIgnoreCase("delay")){ 
						if(args.length<2){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("usagedelaymessage")));
							return false;
						}
						if (!p.hasPermission("rtp.delay")){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage")));
							return false;
						}

						if (isInteger(args[1]) == false){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("usagedelaymessage")));
							return false;
						}
						int delay = Integer.parseInt(args[1]);
						delay = delay*20;
						this.getConfig().set("delay", delay);
						saveConfig();
						p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("delaysetmessage")));
						return true; 
					}


					if(args.length >= 2){   // rtp tp player

						Player tped = Bukkit.getPlayer(args[0]); 


						if (tped == null){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("notonlinemessage")));
							return false;
						}
						if (!tped.equals(p) && !p.hasPermission("rtp.tp.others") || !p.hasPermission("rtp.tp")){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage")));
							return false;
						}
						if(p.hasPermission("rtp.bypass") && checkCD(p) == true){
							return false;
						}
						if (!tped.isOnline()){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("notonlinemessage")));
							return false;
						}


						World world =  getServer().getWorld(args[1]);

						if (args[1].equalsIgnoreCase("this")){
							world = p.getWorld();
						}
						if (world == null){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("doesntexistsmessage")));
							return false;
						}

						if(!p.hasPermission("rtp.world." + args[1]) && !p.hasPermission("rtp.worlds") && !p.hasPermission("rtp.tp.others")){
							p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage")));
							return false;
						}


						genCoord(world, tped);

						if (args.length == 3){ // SI SELECTION DE BIOME
							if (!p.hasPermission("rtp.biome."+args[2]) && !p.hasPermission("rtp.biomes") && p.hasPermission("rtp.tp.others") ){
								p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage")));
								return false;
							}
							int ii = 0;
							while (!TP.getBlock().getBiome().toString().equalsIgnoreCase(args[2])){
								ii = ii+1;
								genCoord(world, tped);
								if (ii>100){
									break;
								}
							}
						}
						if (i>300){i=0;return false;};
						if (!p.hasPermission("rtp.bypass") && checkCD(p) == true){
							return false;
						}
						if(p.hasPermission("rtp.bypass") || checkCD(p) == false ){
							tpPlayer(tped, TP);
						}
						return true;

					}
					help(p); // Redirige vers l help
				}
			}
		}
		return true;
	}

	@EventHandler
	public void signPlace(SignChangeEvent e) {

		if (e.getLine(0).equalsIgnoreCase("[rtp]") && e.getPlayer().hasPermission("rtp.placesign")) {
			e.setLine(0, ChatColor.BLUE + "[RandomTeleport]");
			e.setLine(2, ChatColor.GREEN + e.getLine(2));
		}
	}

	@EventHandler
	public void signInteract(PlayerInteractEvent e) {
		if (e.getAction() == Action.RIGHT_CLICK_BLOCK) {
			if (e.getClickedBlock().getType() == Material.SIGN || e.getClickedBlock().getType() == Material.SIGN_POST
					|| e.getClickedBlock().getType() == Material.WALL_SIGN) {
				Sign sign = (Sign) e.getClickedBlock().getState();
				if (sign.getLine(0).contains("[RandomTeleport]")) {
					if (sign.getLine(2).isEmpty()){
						e.getPlayer().getServer().dispatchCommand(e.getPlayer(), "rtp");

					} else {
						String signworld = sign.getLine(2);
						signworld = signworld.substring(1);
						signworld = signworld.substring(1);

						e.getPlayer().getServer().dispatchCommand(e.getPlayer(), "rtp " + e.getPlayer().getName() + " " + signworld);
					}
				}
			}
		}
	}

	public void genCoord(World w, Player p){
		i = i+1;
		if (i>300){p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("notfoundmessage"))); return;}
		x = r.nextInt((getConfig().getInt("Worlds." + w.getName() + ".xMax") + 1)
				- getConfig().getInt("Worlds." + w.getName() + ".xMin"))
				+ getConfig().getInt("Worlds." + w.getName() + ".xMin");
		z = r.nextInt(getConfig().getInt("Worlds." + w.getName() + ".zMax") + 1
				- getConfig().getInt("Worlds." + w.getName() + ".zMin") )
				+ getConfig().getInt("Worlds." + w.getName() + ".zMin");
		y = w.getHighestBlockYAt(x, z);

		TP = new Location(w,x+0.5,y,z+0.5);

		if (w.getName().equalsIgnoreCase("world_nether")) {
			y = 10;
			TP = new Location(w,x+0.5,y,z+0.5);
			String type = TP.getBlock().getType().toString();
			if (!(type=="AIR")) {  
				while (!(type=="AIR")) {
					y++; 
					if (y> 90){ 
						genCoord(w,p);
						break;
					}
					Location newy = new Location (TP.getWorld(), x, y, z); 
					type = newy.getBlock().getType().toString(); 
				}
			}
		}

		TP = new Location(w,x+0.5,y,z+0.5);
		Location TPy = new Location(TP.getWorld(),TP.getX(),TP.getY()-1,TP.getZ());
		if (TP.getWorld().getBlockAt(TP).getType().equals(Material.LAVA)
				|| TP.getWorld().getBlockAt(TP).getType().equals(Material.STATIONARY_LAVA)
				|| TPy.getWorld().getBlockAt(TPy).getType().equals(Material.STATIONARY_LAVA) 
				|| TP.getWorld().getBlockAt(TP).getType().equals(Material.WATER)
				|| TPy.getWorld().getBlockAt(TPy).getType().equals(Material.STATIONARY_WATER)
				|| TPy.getWorld().getBlockAt(TPy).getType().equals(Material.AIR)){
			genCoord(w,p);
			return;
		}

		if (isOutsideOfBorder(TP) == true){
			genCoord(w,p);
			return;
		}
		if (this.getConfig().getBoolean("tpprotection")==true && !playerHasPermission(TP,p)){
			genCoord(w,p);
			return;
		}
		i = 0;
	}

	public void help(Player p){
		// HELP HELP HELP HELP HELP HELP HELP
		if (p.hasPermission("rtp.help")){
			p.sendMessage(
					ChatColor.GOLD + "~~" + ChatColor.AQUA + " RandomTeleport " + ChatColor.GOLD + "~~");
			p.sendMessage(ChatColor.GRAY + "By : Ullrimax");
			if (p.hasPermission("rtp.tp")){
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("rtphelpmessage")));
			}
			if (p.hasPermission("rtp.tp.others") || p.hasPermission("rtp.worlds") || p.hasPermission("rtp.biomes")){
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("rtpothershelpmessage")));
			}
			if (p.hasPermission("rtp.set")){
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("sethelpmessage")));
			}
			if (p.hasPermission("rtp.cooldown")){
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("cooldownhelpmessage")));
			}
			if (p.hasPermission("rtp.delay")){
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("delayhelpmessage")));
			}
			if (p.hasPermission("rtp.reload")){
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("reloadhelpmessage")));
			}
			if (p.hasPermission("rtp.tpprotection")){
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("tpprotectionhelpmessage")));
			}

		} else { p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("permissionmessage"))); }
		// HELP HELP HELP HELP HELP HELP HELP
	}


	public boolean checkCD(Player p){
		int cooldownTime = this.getConfig().getInt("cooldown");
		if(cooldowns.containsKey(p.getName())) {
			long secondsLeft = ((cooldowns.get(p.getName())/1000)+cooldownTime) - (System.currentTimeMillis()/1000);
			if(secondsLeft>0) {
				String cantusemessage = this.getConfig().getString("cantusemessage");
				p.sendMessage(ChatColor.translateAlternateColorCodes('&',cantusemessage.replace("$secondsLeft$", Long.toString(secondsLeft))));
				return true;
			}
		}
		return false;
	}

	@EventHandler
	public void onPlayerMove(PlayerMoveEvent e){
		Location from = e.getFrom();
		Location to = e.getTo();
		if (from.getX() != to.getX() || from.getY() != to.getY() || from.getZ() != to.getZ()) {
			final Player p = e.getPlayer();
			if(delays.containsKey(p.getName())){
				if(player.contains(p.getName())){
					player.remove(p.getName());
					delays.remove(p.getName());
					p.sendMessage(ChatColor.translateAlternateColorCodes('&',this.getConfig().getString("cancelmessage")));
				}
				return;
			}
		}
	}


	public void tpPlayer(Player p, Location loc){

		if (p.isOp() == false){
			cooldowns.put(p.getName(), System.currentTimeMillis()); }

		if (delay>0){
			String delaystartmessage = this.getConfig().getString("delaystartmessage");
			p.sendMessage(ChatColor.translateAlternateColorCodes('&',delaystartmessage.replace("$delay$", Integer.toString(delay/20))));
		}
		player.add(p.getName());
		delays.put(p.getName(), System.currentTimeMillis());
		delay = this.getConfig().getInt("delay");

		this.getServer().getScheduler().scheduleSyncDelayedTask(this, new Runnable() {
			public void run() {
				if(player.contains(p.getName()) && delays.containsKey(p.getName())){
					delays.remove(p.getName());
					p.teleport(loc);
					p.sendMessage(ChatColor.translateAlternateColorCodes('&',getConfig().getString("tpmessage")));
				}
			}
		}, delay);

	}

	public static boolean isInteger(String s) {
		try { 
			Integer.parseInt(s); 
		} catch(NumberFormatException e) { 
			return false; 
		} catch(NullPointerException e) {
			return false;
		}
		// only got here if we didn't return false
		return true;
	}

	public boolean isOutsideOfBorder(Location loc) {
		WorldBorder border = loc.getWorld().getWorldBorder();
		double x = loc.getX();
		double z = loc.getZ();
		double size = border.getSize();
		double xcenter = border.getCenter().getX();
		double zcenter = border.getCenter().getZ();
		if ((x > size+xcenter || (-x) > size-xcenter) || (z > size+zcenter || (-z) > size-zcenter)){
			return true;
		}
		return false;
	}

	public boolean playerHasPermission(Location location, Player player) {
		BlockBreakEvent testEvent = new BlockBreakEvent(location.getBlock(), player);
		Bukkit.getPluginManager().callEvent(testEvent);
		if (testEvent.isCancelled()) {
			return false;
		}
		return true;
	}


}
